#################################################################################################
##       AIDE
##      in-game
#################################################################################################
# Définition des variables utilisées dans le menu d'aide

# Chaines pour les traductions (utilisées dans le contenu de l'aide)
define preferences = _("Preferences")
define load = _("Load Game")
define retour = _("Return")
define main = _("Main Menu") 
define save = _("Save Game")
define quit = _("Quit")
define display = _("Display")
define volume = _("Volume")
define langue = _("Langue/Language")
define auto_forward = _("Auto-Forward")
define text_speed = _("Text Speed")
define auto_forwardt = _("Auto-Forward Time") 
define help = _("Help")
define bookmark = _("Bookmark")
define read = _("Read")

# Contenue de l'aide (liste / dictionnaire qui sera parcouru par le screen)
define contenu_aide = {
    "resume":[
        {"element":_("Fonctionnement basique"),
        "contenu":_("Pour avancer dans le jeu, effectuez un clic-gauche ou bien pressez la touche espace ou entrée. {#Dans les menus, faites un clic-gauche pour faire un choix, ou utilisez les flèches, et validez votre choix avec la touche Entrée pour l'activer.}\nPour plus de détails cliquez sur les boutons ci-dessous.")}
    ],
    "menu_rapide":[
        {"element":_("Principe"),
        "contenu":_("Pendant le déroulement de l'histoire, en bas à droite de l'écran, diverses icônes permettent d'accéder rapidement à diverses fonctionnalités.")},
        {"element":_(u"{font=gui/open-iconic.ttf}\uE092{/font} Pause"),
        "contenu":_("Met l'histoire en pause en coupant le son, puis la restaure au même point")},
        {"element":_(u"{font=gui/open-iconic.ttf}\uE0B0{/font} Aide"),
        "contenu":_("Affiche cet écran d'aide.")},
        {"element":_(u"{font=gui/open-iconic.ttf}\uE093{/font}/ {font=gui/open-iconic.ttf}\uE099{/font} Auto On/Off"),
        "contenu":_("Bascule entre l'avancement automatique du texte ou l'avance manuelle")},
        {"element":_(u"{font=gui/open-iconic.ttf}\uE095{/font} Retour"),
        "contenu":_("Effectue un retour en arrière. Ce retour permet de relire les textes précédents.")},
        {"element":_(u"{font=gui/open-iconic.ttf}\uE041{/font} Options"),
        "contenu":_("Accès au menu des options et paramètres.")}#,
#        {"element":_(u"{font=gui/open-iconic.ttf}\uE09B{/font} Sommaire"),
#        "contenu":_("Retour au début du jeu (Menu principal)")},
#        {"element":_(u"{font=gui/open-iconic.ttf}\uE0AB{/font} Quitter"),
#        "contenu":_("Quitter le jeu; la partie prend fin et se ferme.")}    
        ],
    "menu_jeu":[
        {"element":_("Accès au menu du jeu"),
        "contenu":_("Durant le jeu, un clic-droit ou la touche échap permettent d'afficher le menu du jeu.")},
        {"element": u"{font=gui/open-iconic.ttf}\uE003{/font} [retour!t]",
        "contenu":_("Retourner au jeu.")},
       {"element":u"{font=gui/open-iconic.ttf}\uE0DA{/font} [preferences!t]",
        "contenu":_("Change les préférences et les paramètres du jeu")},
       {"element":u"{font=gui/open-iconic.ttf}\uE021{/font} [save!t]",
        "contenu":_("Cela vous permet de sauvegarder le jeu en cliquant sur un emplacement de sauvegarde.")},
        {"element":u"{font=gui/open-iconic.ttf}\uE021{/font} [load!t]",
        "contenu":_('Vous permet de charger un jeu en cliquant sur un emplacement de sauvegarde. Cliquer sur "Auto" vous donne accès aux sauvegardes automatiques.')},
       {"element":u"{font=gui/open-iconic.ttf}\uE078{/font} [main!t]",
        "contenu":_("Retourne au menu principal, met fin à la partie en cours.")},
#       {"element":_("Aide"),
#        "contenu":_("Affiche cet écran d'aide.")},
       {"element":u"{font=gui/open-iconic.ttf}\uE0AB{/font} [quit!t]",
        "contenu":_("Quitter le jeu; la partie prend fin et se ferme.")}
    ],
    "souris_clavier1":[
       {"element":_("Clic-gauche, Entrée"),
        "contenu":_("Avance dans le jeu, active les options des menus, les boutons et les indicateurs.")},
       {"element":_("Espace"),
        "contenu":_("Avance dans le jeu, mais n'active pas les options.")},
       {"element":_("Flèches"),
        "contenu":_("Sélectionne les options des menus, les boutons et les indicateurs.")},
       {"element":_("Molette en haut, Page-haut."),
        "contenu":_("Effectue un retour en arrière. Ce retour permet de remonter le temps, affiche les textes précédents, et permet même de modifier ses choix dans les menus.")},
       {"element":_("Molette en bas, Page en bas."),
        "contenu":_("Permet de ré-avancer dans le jeu, annulant ainsi les retours en arrière.")},
       {"element":_("Clic-droit, échap"),
        "contenu":_("Permet d'accéder au menu du jeu. Si on est dans le menu du jeu, permet de revenir au jeu.")}
        ],
    "souris_clavier2":[
       {"element":_("Clic-milieu, H"),
        "contenu":_("Cache la fenêtre de texte et autres affichages temporaires.")},
       {"element":_("F"),
        "contenu":_("Permet d'alterner le plein écran et le mode fenêtré")},
       {"element":_("S"),
        "contenu":_("Effectue une capture d'écran nommée screenshotxxxx.png (xxxx étant un numéro de attribué par le logiciel.)")},
       {"element":_("Alt-F4, Commande-Q"),
        "contenu":_("Quitte le jeu.")},
       {"element":_("Suppr"),
        "contenu":_("Quand un emplacement de sauvegarde est sélectionné, supprime la sauvegarde.")}
    ],
    "save_load":[
       {"element":_("Principe"),
        "contenu":_("Si vous devez interrompre votre lecture, vous pouvez enregistrer votre position dans l'histoire gâce au signets. L'accès aux signets se fait dans l'écran d'accueil (récupération seulement) ou le menu des options.")},
       {"element":_("Navigation"),
        "contenu":_("Vous pouvez enregistrer 4 signets par écran. Pour enregistrer plus de signets, utilisez la barre de navigation en haut de l'écran. Le bouton \"Auto\" correspond aux signets automatiques, enregistrés sans intervention de votre part.")},
       {"element":u"{font=gui/open-iconic.ttf}\uE021{/font} [save!t]",
        "contenu":_("Cliquez sur un emplacement vide pour créer un nouveau signet. Cliquer sur un emplacement occupé détruit le signet existant pour le remplacer le nouveau signet.")},
       {"element":u"{font=gui/open-iconic.ttf}\uE021{/font} [load!t]",
        "contenu":_("Pour retourner à un emplacement dans l'histoire précédemment sauvegardé, cliquer sur l'emplacement correspondant.")}
    ],
    "legal":[
       {"element":_("Notice légale"),
        "contenu":_("Ce jeu utilise du code provenant de plusieurs projets de logiciels libres. Pour obtenir la liste, ainsi que les adresses à partir desquelles le code source peut être téléchargé, consultez le fichier LICENSE.txt dans le répertoire 'renpy'.")}
    ],
    "preferences":[
       {"element":u"{font=gui/open-iconic.ttf}\uE0A0{/font} [display!t]",
        "contenu":_("Alterne entre plein-écran et mode fenêtré.")},
       {"element":u"{font=gui/open-iconic.ttf}\uE0D5{/font} [volume!t]",
        "contenu":_("Contrôle le volume de la musique et des sons. Plus les indicateurs sont à droite, plus les volumes sont forts.")},
        # Commenter tant que les traductions ne sont pas faites
       {"element":u"{font=gui/open-iconic.ttf}\uE069{/font} [langue!t]",
        "contenu":_("Permet de sélectionner la langue de l'histoire et de l'interface (choix entre anglais et français)")},
        
       #{"element":_("Transitions"),
       # "contenu":_("Contrôle le type de transitions entre les écrans de jeu.")},
       {"element":u"{font=gui/open-iconic.ttf}\uE096{/font} [text_speed!t]",
        "contenu":_("Contrôle la vitesse à laquelle le texte défile. Plus l'indicateur est à droite, plus le texte défilera rapidement. Un indicateur totalement à droite impliquera un texte affiché instantanément.")},
       {"element":u"{font=gui/open-iconic.ttf}\uE098{/font} [auto_forward!t]",
        "contenu":_("Si l'avance automatique est sélectionnée, le texte avance sans intervention du lecteur.")},
       {"element":u"{font=gui/open-iconic.ttf}\uE0CD{/font} [auto_forwardt!t]",
        "contenu":_("Contrôle l'avancement automatique en fonction du temps. Plus l'indicateur est à gauche, moins il faudra de temps pour que le jeu continue de lui-même. Si l'indicateur est totalement à droite, cela signifie que l'avancement automatique est désactivé.")}

    ]       
}

define liste_categories = ["resume","menu_jeu","menu_rapide","preferences",'save_load',"souris_clavier1","souris_clavier2","legal"]
define titre_categories = {"resume":_("Aide rapide"),"menu_jeu":_("Menu du jeu"),"preferences":_("Préférences et paramètres"),"souris_clavier1":_("Raccourcis clavier/souris (début)"),"souris_clavier2":_("Raccourcis clavier/souris (fin)"),"legal":_("Licences"),"menu_rapide":_("Menu rapide (Icônes)"), "save_load":_("Gestion des signets")}


#################################################################################################
# Écrans utilisés pour l'affichage de l'aide

#------------------------------------------------------------------------------------------------
# Screen principal avec le titre et les boutons de navigation

screen ecran_aide:
    
    # Détermination du contenu affiché au premier affichage de l'aide
    default categorie = "resume"
    
    # Affichage du fond
    add Solid(couleur_interieur) # Spécifique à Ivy
    add "fonds aide"
    
    # Affichage du titre
    text titre_categories[categorie] xalign 0.5 ypos 40 size 35 style "titre"
    
    # Affichage de l'intérieur, en fonction de ce qu'il y a à afficher
    fixed:
        pos (50,100)
        xysize (988,412)
        yfill
        use contenu_ecran_aide(categorie)
        
    fixed:        
        xalign 0.5
        yalign 0.95
        xsize 988
        ymaximum 60
        xfill True
        style_group "aide_nav"
        # Affichage de boutons de navigation
        if categorie is not "resume":
            textbutton (_("Précédent")):
                xalign 0.0 #xoffset 50
                #yalign 1.0 #yoffset -50
                action SetScreenVariable("categorie",liste_categories[liste_categories.index(categorie)-1])
        textbutton (_("Retour")):
            xalign 0.5
            #yalign 1.0 #yoffset -50
            action Return()
        if categorie is not "legal":
            textbutton (_("Suivant")):
                xalign 1.0 #xoffset  -50
                #yalign 1.0 #yoffset -50
                action SetScreenVariable("categorie",liste_categories[liste_categories.index(categorie)+1])

#------------------------------------------------------------------------------------------------
# Screen du contenu

screen contenu_ecran_aide(categorie):
    if categorie == "resume":
        vbox:
            xfill True
            text contenu_aide[categorie][0]["element"] style "aide_element"
            text contenu_aide[categorie][0]["contenu"] size 18
            null height 20
            vbox:
                style_group "aide"
                xalign 0.5
                textbutton _("Navigation") action SetScreenVariable("categorie","menu_jeu")
                null height 10
                textbutton _("Icônes in-game") action SetScreenVariable("categorie","menu_rapide")
                null height 10
                textbutton _("Paramètres et options") action SetScreenVariable("categorie","preferences")
                null height 10
                textbutton _("Gestion des signets") action SetScreenVariable("categorie","save_load")
                null height 10
                textbutton _("Raccourcis Clavier / Souris") action SetScreenVariable("categorie","souris_clavier1")
                null height 10
                textbutton _("Informations légales") action SetScreenVariable("categorie","legal")
    elif categorie == "legal":
        vbox:
            text contenu_aide[categorie][0]["element"] style "aide_element"
            text contenu_aide[categorie][0]["contenu"] size 18

    else:
        if len(contenu_aide[categorie])%2 == 0:
            $ lignes = len(contenu_aide[categorie])//2
        else:
            $ lignes = len(contenu_aide[categorie])//2 + 1
        vbox:
            pos (0,0)
            xmaximum 474
            for i in range(lignes):
                vbox:
                    text contenu_aide[categorie][i]["element"] style "aide_element"
                    text contenu_aide[categorie][i]["contenu"] size 18
                    null height 10
        vbox:
            pos (494,0)
            xmaximum 474
            for i in range(lignes,len(contenu_aide[categorie])):
                vbox:
                    text contenu_aide[categorie][i]["element"] style "aide_element"
                    text contenu_aide[categorie][i]["contenu"] size 18
                    null height 10
                    
#################################################################################################
# Label appelé par la fonction Help()

label aide:

    window hide

    call screen ecran_aide
    window show
    return 
    
    return

# Variantes pour appeler un écran précis de l'aide
label aide_reglages:

    window hide

    call screen ecran_aide(categorie="preferences")
    window show
    return 
    
    return    

label aide_rapide:

    window hide

    call screen ecran_aide(categorie="menu_rapide")
    window show
    return 
    
    return     
    
label aide_signets:

    window hide

    call screen ecran_aide(categorie="save_load")
    window show
    return 
    
    return    
#################################################################################################
# Styles utilisés dans le screen

init -2:    
    style aide_element is titre:
        text_align 0.0
        xalign 0.0

    style aide_button is bouton_plein:
        size_group "aide"


    style aide_button_text is mo_button_text
    
    style aide_nav:
        size_group "aide_nav"
        yalign 1.0

    style aide_nav_button is signets_button
    style aide_nav_button_text is signets_button_text

    

    