##############################################################################
##############################################################################
#
# Variantes des Screens Personnalisés pmour les versions Android
# (menu rapide, pour l'accueil, nv menu des options, navigation, load et save)
#
##############################################################################
##############################################################################


##############################################################################
# Menu principal
#
screen main_menu:

    # Pour être sûr que tout autre menu est remplacé
    tag menu
    
    # Version Android
    variant "android"

    # Le fond du menu principal
    window:
        style "fond_accueil"

    # Les boutons du menu principal.
    frame:
        style_group "mm"
        xalign 0.5
        yalign 0.95
        background None

        has hbox

## Provisoire tant qu'il n'y a pas de traductions => On montre le menu d'aide
#        textbutton u"{font=gui/open-iconic.ttf}\uE0B0{/font}\n[help!t]":
#            style "accueil_android"
#            action Help()

## Désactivé tant qu'il n'y a pas de traductions
        if _preferences.language == None:
            textbutton u"{font=gui/open-iconic.ttf}\uE069{/font}\nRead in\nEnglish":
                style "accueil_android"
                action Language("en")
        else:
            textbutton u"{font=gui/open-iconic.ttf}\uE069{/font}\nLire en\nfrançais":
                style "accueil_android"
                action Language(None)
            
            
        textbutton u"{font=gui/open-iconic.ttf}\uE021{/font}\n[bookmark!t]":
            style "accueil_android"
            action ShowMenu("use_signet")

        textbutton u"{font=gui/open-iconic.ttf}{size=80}\uE0A9{/size}{/font}\n{size=50}[read!t]{/size}":
            style "accueil_android"
            action Start()
        
        textbutton u"{font=gui/open-iconic.ttf}\uE041{/font}\nOptions":
            style "accueil_android"
            action ShowMenu("menu_options")
        
        textbutton u"{font=gui/open-iconic.ttf}\uE0AB{/font}\n[quit!t]":
            style "accueil_android"
            action Quit(confirm=False) 
            
    add "titre legende ivy" pos(358,0)

        
init -2:
    # styles pour l'affichage des boutons de l'écran d'accueil
    style accueil_android:
        xminimum 185
        ysize 100
        xmargin 25
        background None
        yalign 0.75
        
    style accueil_android_text is titre:
        text_align 0.5       
            
##############################################################################
# Menu rapide perso
#

screen menu_rapide:
    
    # Version Android => pas de menu rapide (à la place on a un menu des options renforcé)
    variant "android"
    
    null width 1
        

##############################################################################
# Navigation
#

screen navigation:
    
    # version pour Android (avec boutons plus larges) et sans mécanisme de "hover"
    variant "android"

    # on définit l'endroit où mène le bouton d'aide
    default label_aide = config.help
    # Fond du menu jeu
    window:
        style "ecran_options"
        
    frame:
        style_group "accueil"
        xalign 0.5
        yalign 0.99
        background None

        has hbox

        textbutton u"{font=gui/open-iconic.ttf}\uE0B0{/font}\n[help!t]":
            style "accueil_android"
            action Help()
        
        textbutton u"{font=gui/open-iconic.ttf}{size=60}\uE003{/size}{/font}{size=50}\n[retour!t]{/size}":
            style "accueil_android"
            action Return()
            
        textbutton u"{font=gui/open-iconic.ttf}\uE0AB{/font}\n [quit!t]":
            style "accueil_android"
            action Quit() 

    
    
##############################################################################
# Menu Oui/Non
#


screen yesno_prompt:

    modal True
    
    # Version android : boutons oui/non plus gros
    variant "android"

    window:
        style "ecran_options"

    frame:
        style_group "yesno_android"

        xfill True
        xmargin .05
        ypos .1
        yanchor 0
        ypadding .05

        has vbox:
            xalign .5
            yalign .5
            spacing 30

        label _(message):
            xalign 0.5

        hbox:
            xalign 0.5
            spacing 100

            textbutton _("Yes") action yes_action
            textbutton _("No") action no_action

    # Clic droit ou échap pour "non"
    key "game_menu" action no_action

init -2:
    
    style yesno_android:
        size_group "yesno_android"
        
    style yesno_android_label_text is yesno_label_text # le texte est inchangé par rapport à la version "normale"
        
    style yesno_android_button is yesno_button: # On agrandit les boutons
        xpadding 30
        ypadding 20
        
    style yesno_android_button_text is yesno_button_text #Aspect du texte des boutons inchangé
    
    style yesno_android_frame is yesno_frame #Aspect du cadre inchangé
    
##############################################################################
# Menu des options
#
# La version android combine le menu des options classique et certaines fonctionnalités du menu rapide

screen menu_options:
    
    variant "android"
    
    # Ecran qui s'affiche quand on clique droit ou qu'on y accède par l'accueil
    
       
    # Pour être sûr que tout autre menu est remplacé
    tag menu

    # Fond du menu jeu
    window:
        style "ecran_options"

    # Boutons de navigation.
    frame:
        style_group "mo"
        xalign 0.2 # on décale le boutons sur la gache par rapport au menu normal pour laisser place aux nouvelle fonctionnalités
        yalign 0.5

        has vbox
        
        hbox:

            textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE0DA{/size}{/font}\n[preferences!t]" action ShowMenu("reglages")

            textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE003{/size}{/font}\n[retour!t]" action Return()
        hbox:

            textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE021{/size}{/font}\n[load!t]" action ShowMenu("use_signet")

            textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE078{/size}{/font}\n[main!t]" action MainMenu()
        hbox:

            textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE021{/size}{/font}\n[save!t]" action [ShowMenu("pose_signet"), SensitiveIf(main_menu is not True)]

            textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE0AB{/size}{/font}\n[quit!t]" action Quit()
            
    # fonctionnalités du "menu" rapide dans la version pc
    frame:
        style_group "mo"
        xalign 0.8 # On place les nvx bouton sur la droite de l'écran
        yalign 0.5

        has vbox
        
        textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE092{/size}{/font}\nPause":
            action Show("ecran_pause")
            
        textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE0B0{/size}{/font}\n[help!t]":
            action Help()
        
        if _preferences.afm_enable:
            textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE099{/size}{/font}\nAuto Off":
                action Preference("auto-forward", "disable")
        else:
            textbutton u"{font=gui/open-iconic.ttf}{size=40}\uE093{/size}{/font}\nAuto On":
                action Preference("auto-forward", "enable")
            

##############################################################################
# Gestures
#
# Application du rollback/rollforward avec les gestures
                
init -2 python:
    
    # rollforward en glissant le doigt vers le bas
    config.gestures = { "s" : "rollforward" }
    
    # rollback en glissant le doigt vers le haut
    config.gestures = { "n" : "rollback" }

    # Menu des options en glissant le doigt vers la gauche
    config.gestures = { "w" : "game_menu" }

