###############################################################################################
###############################################################################################
###
###     Fonctions et paramètres communs à tous les jeux
###
###############################################################################################
###############################################################################################

###############################################################################################
#  Fonctions
#--------------------------------------------------------------------------------------------------
# fonction pour l'affichage de la licence des assets dans les crédits
init -1 python :
    def affich_licence (lic,version):
        # lic doit être un tableau avec les diverses variantes de licences CC (aka by, sa, nc)
        # ou la chaîne "zero" pour CC0
        # ou la chaîne "lal" pour Licence Art libre
        # 
        # Version correspond à la version de CC (2.0,3.0,4.0) ou None pour CC0
        im = ""
        txt = ""
        lien = ""
        
        # cas de la licence cc0 (domaine public)
        if lic == "zero":
            if _preferences.language == None:
                return "{image=cc/Cc-zero.png} {a=https://creativecommons.org/publicdomain/zero/1.0/deed.fr}CC0 (Domaine public){/a}"
            else:
                return "{image=cc/Cc-zero.png} {a=https://creativecommons.org/publicdomain/zero/1.0}CC0 (Public domain){/a}"
        
        #cas de la licence art libre
        elif lic == "lal":
            if _preferences.language == None:
                return "{image=cc/lal.png} {a=http://artlibre.org/licence/lal/}LAL (licence art libre){/a}"
            else:
                return "{image=cc/lal.png} {a=http://artlibre.org/licence/lal/en/}FAL (Free Art License){/a}"
        # Autres licences CC
        else:
            for el_lic in lic:
                # On ajoute les diverses images
                im += "{image=cc/Cc-" + el_lic +".png} "
                # texte affiché à l'écran
                txt += "-" + el_lic.upper()
                # construction du lien vers l'explication des licences (le by est toujours présent, on n'ajoute que les autres)
                if el_lic == 'by':
                    pass
                else:
                    lien += "-" + el_lic
            # exemple de résultat obtenu
            #{image=cc/Cc-by.png} {image=cc/Cc-sa.png}  {a=http://creativecommons.org/licenses/by-sa/2.0/fr/} CC-BY-SA{/a}
            chaine = im + "{a=http://creativecommons.org/licenses/by" + lien + "/" + version 
            if _preferences.language == None:
                chaine += "/fr"
            chaine += "/}CC" + txt + "{/a}"
            return chaine

#--------------------------------------------------------------------------------------------------
# fonctions pour activer les hyperliens https
    def new_hyperlink_style(target):
        return style.hyperlink_text
   
    def new_hyperlink_function(target):
        if target.startswith("http:") or target.startswith("https:"):
            try:
                import webbrowser
                webbrowser.open(target)
            except:
                pass
        else:
            renpy.call_in_new_context(target)

    # Redéfinition des fonctions d'hyperliens avec les nouvelles cibles
    style.default.hyperlink_functions = (new_hyperlink_style, new_hyperlink_function, None)

#--------------------------------------------------------------------------------------------------
# Fonction pour recolorer des images noires
# Donner l'image, la couleur (sous forme hexa) et l'opacité (optionnelle = complètement opaque par défaut)
init -3 python:
    def recolorer(image,couleur,ombre="#fff",opacite=1.0):
        return im.MatrixColor(image, im.matrix.colorize(couleur, ombre) *  im.matrix.opacity(opacite))
    
    
###############################################################################################
#  Paramètres de configuration
    
#--------------------------------------------------------------------------------------------------
# Contrôle manuel de la fenêtre NVL
init python:
    config.empty_window = nvl_show_core
    config.window_hide_transition = None
    config.window_show_transition = None
    
#--------------------------------------------------------------------------------------------------
# Variables de configuration diverses, principalement issues du fichier options.rpy
init -1 python hide:



    ## Contrôle la largeur et la hauteur de la fenêtre.

    config.screen_width = 1088
    config.screen_height = 612

    ## Titre de la fenêtre (lorsque le jeu se fait en mode fenêtré).

    config.window_title = u"Ivy"


    ## Mettez cette option à False pour désactiver les sons.

    config.has_sound = False

    ## Mettez cette option à False si le jeu n'a pas de musique.

    config.has_music = True

    ## Mettez cette option à True si le jeu contient des voix.

    config.has_voice = False

    #########################################
    ## Aide.

    config.help = "aide"

        #########################################
    ## Transitions.

    ## Transition lorsque l'on rentre dans le menu du jeu depuis le jeu
    config.enter_transition = None

    ## Transition lorsque l'on retourne au jeu depuis le menu jeu
    config.exit_transition = None

    ## Transition entre deux écran du menu jeu
    config.intra_transition = None

    ## Transition lorsque l'on rentre dans le menu jeu depuis le menu principal
    config.main_game_transition = None

    ## Transition lorsque l'on retourne au menu principal depuis le jeu
    config.game_main_transition = None

    ## Transition lorsque l'on entre dans le menu principal depuis le
    ## splashscreen
    config.end_splash_transition = None

    ## Transtion lorsque l'on entre dans le menu principal après la fin du jeu
    config.end_game_transition = None

    ## Transition lorsque une partie est chargée
    config.after_load_transition = None

    ## Transition lorsque le fenêtre apparaît.
    config.window_show_transition = None

    ## Transition lorsque le fenêtre se cache
    config.window_hide_transition = None

    ## Transition lorsque l'on passe en mode NVL après avoir été en mode ADV.
    config.adv_nvl_transition = dissolve

    ## Transition lorsque l'on passe en mode ADV après avoir été en mode NVL.
    config.nvl_adv_transition = dissolve

    ## Transition lorsque l'on montre le menu Oui/Non
    config.enter_yesno_transition = None

    ## Transition lorsque l'on cache le menu Oui/Non
    config.exit_yesno_transition = None

    ## Transition au début d'une répétition (replay)
    config.enter_replay_transition = None

    ## Transition à la fin d'une répétition (replay)
    config.exit_replay_transition = None

    ## Transition lorsque une image change via l'utilisation de l'instruction
    ## 'say' contenant l'attribut 'image'.
    config.say_attribute_transition = None

    #########################################
    ## Nom du répertoire où les données du jeu sont stockées. (Il est
    ## nécessaire que cela soit indiqué tôt, avant tout autre code 
    ## d'initiation.)
python early:
    config.save_directory = "ivy"

init -1 python hide:
    #########################################
    ## Valeurs par défaut des préférences

    ## Note: ces options sont évaluées uniquement au premier démarrage
    ## d'un jeu. Pour les évaluer une seconde fois, faites "Supprimer
    ## persistant"

    ## Mettez cette option à True pour démarrer en mode plein écran

    config.default_fullscreen = False

    ## Vitesse par défaut en nombre de caractères par seconde. 
    ## Mettez 0 pour l'infini.

    config.default_text_cps = 25

    ## Temps par défaut pour l'avancement automatique.

    config.default_afm_time = 6

    # Taille des imagettes des sauvegardes
    
    config.thumbnail_height = int(config.screen_height /4.5)
    config.thumbnail_width = int(config.screen_width /4.5)
    
    # déclaration d'un nouveau canal pour les sons (mais sur le même mixer que les musiques
    renpy.music.register_channel('music2',mixer='music',loop=False)

    
    # icônes personnalisées
    config.window_icon = 'gui/icone.png'
    config.windows_icon = 'gui/iconeW.png'
    
    # Pour la reconnaissance automatique des images
    config.automatic_images = ["_","/"]
    config.automatic_images_strip = ["images"]
    
    # On désactive les sauvegarddes rapides (mais on laisse les automatiques)
    config.has_quicksave = False
    config.autosave_slots = 4 # 4 slots par page seulement avec le nouvelle présentation


    ## Comme on a supprimé le thème, on ajoute une instruction pour récupérer le main menu et autres bricoles
    layout.defaults()
    
###############################################################################################
#  Styles
init python:
    #########################################
    ## Contrôle de l'affichage du texte nvl
    style.nvl_window.background=None
    style.nvl_window.left_padding = 470
    style.nvl_window.right_padding = 50
    style.nvl_window.ypadding = 50
    
    # Changement des styles d'hyperliens (pour les crédits)
    style.hyperlink_text.color = couleur_hyperlien  ## penser à définir cette variable dans le fichier "jeu"_parametres
    style.hyperlink_text.underline = False
    style.hyperlink_text.hover_underline = True


# Style de base, à customiser pour le reste    
init -2:
    
    # style pour les titres : avec une bordure et une ombre
    style titre is text:
        color couleur_interieur
        outlines [(0,couleur_ombre,2,2),(1,couleur_exterieur,0,0)]
    
    style cadre is frame:
        background Solid(couleur_fond)# Version alternative avec Frame voir à la ligne en dessous
        #background Frame(recolorer("gui/frame.png", couleur_exterieur, couleur_interieur),left=12,top=5)

    
    style bouton_cadre is button:
        background Frame(recolorer("gui/cadre_bouton.png",couleur_ombre),4,4)
        insensitive_background Frame(recolorer("gui/cadre_bouton.png",couleur_insensitive),4,4)
        hover_background Solid(couleur_ombre)
        selected_background Frame(recolorer("gui/cadre_bouton.png",couleur_interieur),4,4)
        xpadding 5
        ypadding 5
 
    style bouton_plein is button:
        background Frame(recolorer("gui/bouton_plein.png",couleur_ombre),4,4)
        hover_background Solid(couleur_ombre)
        selected_background Frame(recolorer("gui/bouton_plein.png",couleur_interieur),4,4)
        insensitive_background Frame(recolorer("gui/bouton_plein.png",couleur_insensitive),4,4)
        xpadding 5
        ypadding 5

    style bouton_bicolore is button:
        background Frame(recolorer("gui/bouton_bicolore.png",couleur_ombre),4,4)
        hover_background Solid(couleur_ombre)
        selected_background Frame(recolorer("gui/bouton_bicolore.png",couleur_interieur),4,4)
        insensitive_background Frame(recolorer("gui/bouton_bicolore.png",couleur_insensitive,couleur_insensitive),4,4)
        xpadding 5
        ypadding 5

    style bouton_cadre_texte is text:
        color couleur_ombre
        outlines [(1,"#fff0",0,0),(0,couleur_exterieur,1,1)] # le premier outline sert à s'assurer que le taille du texte ne varie pas, mais produit une couleur totalement transparente.
        
        hover_color couleur_ombre
        hover_outlines [(1,couleur_interieur,0,0)]
        
        selected_color couleur_interieur
        selected_outlines [(1,"#fff0",0,0),(0,couleur_exterieur,1,1)]
        
        insensitive_color couleur_insensitive
        
    style barre is slider:
        left_bar Frame(recolorer("gui/barre_gauche.png", couleur_ombre, couleur_exterieur),left=35,top=0, right=0 ,bottom=0)
        right_bar Frame(recolorer("gui/barre_droite.png", couleur_ombre, couleur_exterieur),left=0,top=0, right=35 ,bottom=0)
        
        hover_left_bar Frame(recolorer("gui/barre_gauche.png",couleur_interieur, couleur_exterieur),left=35,top=0, right=0 ,bottom=0)
        hover_right_bar Frame(recolorer("gui/barre_droite.png",couleur_interieur, couleur_exterieur),left=0,top=0, right=35 ,bottom=0)
        left_gutter 30
        right_gutter 30
        
        thumb recolorer("gui/thumb.png",couleur_ombre, couleur_exterieur)
        hover_thumb recolorer("gui/thumb.png",couleur_interieur, couleur_exterieur)
        thumb_offset 12
        
        ysize 38
        xalign 0.5

    style libelle is text:
        color couleur_interieur
        outlines [(0,couleur_ombre,1,1)]
        
###############################################################################################
#  Personnages communs

# narrateur nvl
define n = Character(None, kind=nvl,what_prefix="{color=[couleur_narration]}",what_suffix="{/color}")
